"""
A wrapper library for getopt which is more convenient to use.

$Id: cmdarg.py,v 1.1 1999/07/13 20:50:23 larsga Exp $
"""

import getopt

class ArgumentException(Exception):
    pass

class Arguments:

    def __init__(self,args,opts,longs=[],required=[]):
        (opts,rem)=getopt.getopt(args,opts,longs)

        self.__opts={}
        for (opt,value) in opts:
            self.__opts[opt]=value

        self.__rem=rem

        for req_opt in required:
            if not self.__opts.has_key(req_opt):
                raise ArgumentException("Required argument '%s' missing" %
                                        req_opt)

    def has_opt(self,opt):
        return self.__opts.has_key(opt)

    def get_opt_value(self,opt):
        return self.__opts[opt]

    def get_remainder(self):
        return self.__rem

def process(args,opts,longs=[],required=[]):
    return Arguments(args,opts,longs,required)
